// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from cob_srvs:srv/SetFloat.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "cob_srvs/srv/set_float.hpp"


#ifndef COB_SRVS__SRV__DETAIL__SET_FLOAT__TRAITS_HPP_
#define COB_SRVS__SRV__DETAIL__SET_FLOAT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "cob_srvs/srv/detail/set_float__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace cob_srvs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetFloat_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: data
  {
    out << "data: ";
    rosidl_generator_traits::value_to_yaml(msg.data, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetFloat_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "data: ";
    rosidl_generator_traits::value_to_yaml(msg.data, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetFloat_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace cob_srvs

namespace rosidl_generator_traits
{

[[deprecated("use cob_srvs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const cob_srvs::srv::SetFloat_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  cob_srvs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use cob_srvs::srv::to_yaml() instead")]]
inline std::string to_yaml(const cob_srvs::srv::SetFloat_Request & msg)
{
  return cob_srvs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<cob_srvs::srv::SetFloat_Request>()
{
  return "cob_srvs::srv::SetFloat_Request";
}

template<>
inline const char * name<cob_srvs::srv::SetFloat_Request>()
{
  return "cob_srvs/srv/SetFloat_Request";
}

template<>
struct has_fixed_size<cob_srvs::srv::SetFloat_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<cob_srvs::srv::SetFloat_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<cob_srvs::srv::SetFloat_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace cob_srvs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetFloat_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: message
  {
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetFloat_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetFloat_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace cob_srvs

namespace rosidl_generator_traits
{

[[deprecated("use cob_srvs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const cob_srvs::srv::SetFloat_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  cob_srvs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use cob_srvs::srv::to_yaml() instead")]]
inline std::string to_yaml(const cob_srvs::srv::SetFloat_Response & msg)
{
  return cob_srvs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<cob_srvs::srv::SetFloat_Response>()
{
  return "cob_srvs::srv::SetFloat_Response";
}

template<>
inline const char * name<cob_srvs::srv::SetFloat_Response>()
{
  return "cob_srvs/srv/SetFloat_Response";
}

template<>
struct has_fixed_size<cob_srvs::srv::SetFloat_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<cob_srvs::srv::SetFloat_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<cob_srvs::srv::SetFloat_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace cob_srvs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetFloat_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetFloat_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetFloat_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace cob_srvs

namespace rosidl_generator_traits
{

[[deprecated("use cob_srvs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const cob_srvs::srv::SetFloat_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  cob_srvs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use cob_srvs::srv::to_yaml() instead")]]
inline std::string to_yaml(const cob_srvs::srv::SetFloat_Event & msg)
{
  return cob_srvs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<cob_srvs::srv::SetFloat_Event>()
{
  return "cob_srvs::srv::SetFloat_Event";
}

template<>
inline const char * name<cob_srvs::srv::SetFloat_Event>()
{
  return "cob_srvs/srv/SetFloat_Event";
}

template<>
struct has_fixed_size<cob_srvs::srv::SetFloat_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<cob_srvs::srv::SetFloat_Event>
  : std::integral_constant<bool, has_bounded_size<cob_srvs::srv::SetFloat_Request>::value && has_bounded_size<cob_srvs::srv::SetFloat_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<cob_srvs::srv::SetFloat_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<cob_srvs::srv::SetFloat>()
{
  return "cob_srvs::srv::SetFloat";
}

template<>
inline const char * name<cob_srvs::srv::SetFloat>()
{
  return "cob_srvs/srv/SetFloat";
}

template<>
struct has_fixed_size<cob_srvs::srv::SetFloat>
  : std::integral_constant<
    bool,
    has_fixed_size<cob_srvs::srv::SetFloat_Request>::value &&
    has_fixed_size<cob_srvs::srv::SetFloat_Response>::value
  >
{
};

template<>
struct has_bounded_size<cob_srvs::srv::SetFloat>
  : std::integral_constant<
    bool,
    has_bounded_size<cob_srvs::srv::SetFloat_Request>::value &&
    has_bounded_size<cob_srvs::srv::SetFloat_Response>::value
  >
{
};

template<>
struct is_service<cob_srvs::srv::SetFloat>
  : std::true_type
{
};

template<>
struct is_service_request<cob_srvs::srv::SetFloat_Request>
  : std::true_type
{
};

template<>
struct is_service_response<cob_srvs::srv::SetFloat_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // COB_SRVS__SRV__DETAIL__SET_FLOAT__TRAITS_HPP_
